Skip to navigation

How to require knowledge-based authentication (KBA) for a recipient

View as Markdown

This topic demonstrates requesting a signature via email while also using Knowledge-based authentication (KBA).

Note: You can configure account-wide authentication policy settings in the Security Settings section in eSignature Admin. See the NDSE Security Settings guide for details.

Run this code example from our Quickstart or launcher projects: Bash, C#, Java, Node.js, PHP, PowerShell, Python, or Ruby.

Required data

Running the code in this how-to requires this data:

Data elementDescription
{ACCESS_CODE}A string, 50 characters or less, that you provide to your recipient for their use in authentication. This string must not contain the symbols <, >, &, and #.
{API_ACCOUNT_ID}A GUID value that identifies your account. This value is automatically generated by Docusign for any account you create. Copy the value from the API Account ID field on the Apps and Keys page.
{BASE_PATH}A string value that forms the root of the URL required to make API calls. The base path value in the example code is set to target the developer environment at
https://<domain>/restapi
Where <domain> is demo.docusign.net for the developer environment and is the result of the GetUserInfo call in production.
{RECIPIENT_ID}A unique string value that you assign to identify each recipient. This value assigns tabs on a per-recipient basis.
{SIGNER_EMAIL}A string value for the email address where the signer will receive a notification of the signing request.
{SIGNER_NAME}A string value for the full name of the signer.

Step 1. Obtain your OAuth token

To make the API call shown in this how-to, you need a valid OAuth access token. Docusign supports access tokens for three different recommended OAuth grant types: Public Authorization Code Grant, Confidential Authorization Code Grant, and JSON Web Token (JWT) Grant. Choose the OAuth grant type appropriate for your scenario.

See Confidential Authorization Code Grant for guidance on your options to get an Confidential Authorization Code Grant OAuth token.

Three icons that represent the three methods a user can use to obtain an OAuth token: JSON Web Token (JWT), Public Authorization Code Grant (ACG), and Confidential Authorization Code grant

Step 2. Construct your API headers

After you have a valid OAuth access token, you are ready to construct the API headers that you will pass to the API call. Construct your headers like this, but make sure to substitute your valid OAuth access token for {ACCESS_TOKEN}.

declare -a Headers=('--header' "Authorization: Bearer ${ACCESS_TOKEN}" \
'--header' "Accept: application/json" \
'--header' "Content-Type: application/json")

Step 3: Construct the request body

Next, create the request body. Replace {RECIPIENT_ID}, {SIGNER_NAME}, and {SIGNER_EMAIL} with your recipient’s data in the JSON request body. The idCheckConfigurationName property is set to the string value of ID Check, which is how the recipient authentication method specifies using KBA.

Note: The sample code provided uses fixed positioning for the signHere tab. If your Docusign account has Document Visibility enabled (via Sending Settings in eSignature Admin), and you have not placed a tab for each signer, you will receive this API error: “Freeform signing is not allowed for your account because it conflicts with other settings, please place fields for each signer.”

Tip: The example Base64-encoded document shown here is a generic sample that you can copy and paste into your own code for testing. There are many free online Base64 encoders/decoders, such as FreeFormatter.com, that you can use to encode the documentBase64 property.

printf \
'{
"documents": [{
"documentBase64":"' > $request_data
cat $doc_base64 >> $request_data
printf '",
"documentId": "1",
"fileExtension": "docx",
"name": "Lorem"
}],
"emailBlurb": "Sample text for email body",
"emailSubject": "Please Sign",
"envelopeIdStamping": "true",
"recipients": {
"signers": [{
"deliveryMethod": "Email",
"name": "'"${RECIPIENT_NAME}"'",
"email": "'"${RECIPIENT_EMAIL}"'",
"idCheckConfigurationName": "ID Check",
"recipientId": "1",
"requireIdLookup": "true",
"routingOrder": "1",
"status": "Created",
"tabs": {
"signHereTabs": [{
"documentId": "1",
"name": "SignHereTab",
"pageNumber": "1",
"recipientId": "1",
"tabLabel": "SignHereTab",
"xPosition": "75",
"yPosition": "572"
}]
}
}]
},
"status": "Sent"
}' >> $request_data

Step 4. Call the eSignature REST API

Now that you have constructed your API headers, make a request to the eSignature REST API Envelopes:create endpoint and include the JSON body to create a new envelope. Here’s how you make the call, but make sure to substitute your API account ID for {ACCOUNT_ID}.

View the source code for this how-to on GitHub:: Bash, C#, Java, Node.js, PHP, PowerShell, Python, or Ruby.

curl --request POST "https://demo.docusign.net/restapi/v2.1/accounts/${account_id}/envelopes" \
"${Headers[@]}" \
--data-binary @${request_data} \
--output ${response}

Expected response

If you run this code example from our Quickstart or launcher projects, you should see a JSON response similar to the code shown.

Sample response
{
"envelopeId": "d8f88de4-xxxx-xxxx-xxxx-fb6a2427741c",
"uri": "/envelopes/d8f88de4-xxxx-xxxx-xxxx-fb6a2427741c",
"statusDateTime": "2020-08-10T17:25:04.3630000Z",
"status": "sent"
}

Next steps